.TH error_logger 3 "kernel  2.13.3" "Ericsson AB" "ERLANG MODULE DEFINITION"
.SH MODULE
error_logger \- Erlang Error Logger
.SH DESCRIPTION
.LP
The Erlang \fIerror logger\fR is an event manager (see OTP Design Principles and gen_event(3)), registered as \fIerror_logger\fR\&. Error, warning and info events are sent to the error logger from the Erlang runtime system and the different Erlang/OTP applications\&. The events are, by default, logged to tty\&. Note that an event from a process \fIP\fR is logged at the node of the group leader of \fIP\fR\&. This means that log output is directed to the node from which a process was created, which not necessarily is the same node as where it is executing\&.
.LP
Initially, \fIerror_logger\fR only has a primitive event handler, which buffers and prints the raw event messages\&. During system startup, the application Kernel replaces this with a \fIstandard event handler\fR, by default one which writes nicely formatted output to tty\&. Kernel can also be configured so that events are logged to file instead, or not logged at all, see kernel(6)\&.
.LP
Also the SASL application, if started, adds its own event handler, which by default writes supervisor-, crash- and progress reports to tty\&. See sasl(6)\&.
.LP
It is recommended that user defined applications should report errors through the error logger, in order to get uniform reports\&. User defined event handlers can be added to handle application specific events\&. (\fIadd_report_handler/1, 2\fR)\&. Also, there is a useful event handler in STDLIB for multi-file logging of events, see \fIlog_mf_h(3)\fR\&.
.LP
Warning events was introduced in Erlang/OTP R9C\&. To retain backwards compatibility, these are by default tagged as errors, thus showing up as error reports in the logs\&. By using the command line flag \fI+W <w | i>\fR, they can instead be tagged as warnings or info\&. Tagging them as warnings may require rewriting existing user defined event handlers\&.

.SH EXPORTS
.LP
.B
error_msg(Format) -> ok
.br
.B
error_msg(Format, Data) -> ok
.br
.B
format(Format, Data) -> ok
.br
.RS
.TP
Types
Format = string()
.br
Data = [term()]
.br
.RE
.RS
.LP
Sends a standard error event to the error logger\&. The \fIFormat\fR and \fIData\fR arguments are the same as the arguments of \fIio:format/2\fR\&. The event is handled by the standard event handler\&.

.nf
1> error_logger:error_msg("An error occurred in ~p~n", [a_module])\&.


=ERROR REPORT==== 11-Aug-2005::14:03:19 ===
An error occurred in a_module
ok
.fi
.SS Warning:
.LP
If called with bad arguments, this function can crash the standard event handler, meaning no further events are logged\&. When in doubt, use \fIerror_report/1\fR instead\&.

.RE
.LP
.B
error_report(Report) -> ok
.br
.RS
.TP
Types
Report = [{Tag, Data} | term()] | string() | term()
.br
 Tag = Data = term()
.br
.RE
.RS
.LP
Sends a standard error report event to the error logger\&. The event is handled by the standard event handler\&.

.nf
2> error_logger:error_report([{tag1,data1},a_term,{tag2,data}])\&.


=ERROR REPORT==== 11-Aug-2005::13:45:41 ===
    tag1: data1
    a_term
    tag2: data
ok
3> error_logger:error_report("Serious error in my module")\&.


=ERROR REPORT==== 11-Aug-2005::13:45:49 ===
Serious error in my module
ok
.fi
.RE
.LP
.B
error_report(Type, Report) -> ok
.br
.RS
.TP
Types
Type = term()
.br
Report = [{Tag, Data} | term()] | string() | term()
.br
 Tag = Data = term()
.br
.RE
.RS
.LP
Sends a user defined error report event to the error logger\&. An event handler to handle the event is supposed to have been added\&. The event is ignored by the standard event handler\&.
.LP
It is recommended that \fIReport\fR follows the same structure as for \fIerror_report/1\fR\&.
.RE
.LP
.B
warning_map() -> Tag
.br
.RS
.TP
Types
Tag = error | warning | info
.br
.RE
.RS
.LP
Returns the current mapping for warning events\&. Events sent using \fIwarning_msg/1, 2\fR or \fIwarning_report/1, 2\fR are tagged as errors (default), warnings or info, depending on the value of the command line flag \fI+W\fR\&.

.nf
os$ erl

Erlang (BEAM) emulator version 5\&.4\&.8 [hipe] [threads:0] [kernel-poll]

Eshell V5\&.4\&.8  (abort with ^G)
1> error_logger:warning_map()\&.

error
2> error_logger:warning_msg("Warnings tagged as: ~p~n", [error])\&.


=ERROR REPORT==== 11-Aug-2005::15:31:23 ===
Warnings tagged as: error
ok
3> 
User switch command
 --> q
os$ erl +W w

Erlang (BEAM) emulator version 5\&.4\&.8 [hipe] [threads:0] [kernel-poll]

Eshell V5\&.4\&.8  (abort with ^G)
1> error_logger:warning_map()\&.

warning
2> error_logger:warning_msg("Warnings tagged as: ~p~n", [warning])\&.


=WARNING REPORT==== 11-Aug-2005::15:31:55 ===
Warnings tagged as: warning
ok
.fi
.RE
.LP
.B
warning_msg(Format) -> ok
.br
.B
warning_msg(Format, Data) -> ok
.br
.RS
.TP
Types
Format = string()
.br
Data = [term()]
.br
.RE
.RS
.LP
Sends a standard warning event to the error logger\&. The \fIFormat\fR and \fIData\fR arguments are the same as the arguments of \fIio:format/2\fR\&. The event is handled by the standard event handler\&. It is tagged either as an error, warning or info, see warning_map/0\&.
.SS Warning:
.LP
If called with bad arguments, this function can crash the standard event handler, meaning no further events are logged\&. When in doubt, use \fIwarning_report/1\fR instead\&.

.RE
.LP
.B
warning_report(Report) -> ok
.br
.RS
.TP
Types
Report = [{Tag, Data} | term()] | string() | term()
.br
 Tag = Data = term()
.br
.RE
.RS
.LP
Sends a standard warning report event to the error logger\&. The event is handled by the standard event handler\&. It is tagged either as an error, warning or info, see warning_map/0\&.
.RE
.LP
.B
warning_report(Type, Report) -> ok
.br
.RS
.TP
Types
Type = term()
.br
Report = [{Tag, Data} | term()] | string() | term()
.br
 Tag = Data = term()
.br
.RE
.RS
.LP
Sends a user defined warning report event to the error logger\&. An event handler to handle the event is supposed to have been added\&. The event is ignored by the standard event handler\&. It is tagged either as an error, warning or info, depending on the value of warning_map/0\&.
.RE
.LP
.B
info_msg(Format) -> ok
.br
.B
info_msg(Format, Data) -> ok
.br
.RS
.TP
Types
Format = string()
.br
Data = [term()]
.br
.RE
.RS
.LP
Sends a standard information event to the error logger\&. The \fIFormat\fR and \fIData\fR arguments are the same as the arguments of \fIio:format/2\fR\&. The event is handled by the standard event handler\&.

.nf
1> error_logger:info_msg("Something happened in ~p~n", [a_module])\&.


=INFO REPORT==== 11-Aug-2005::14:06:15 ===
Something happened in a_module
ok
.fi
.SS Warning:
.LP
If called with bad arguments, this function can crash the standard event handler, meaning no further events are logged\&. When in doubt, use \fIinfo_report/1\fR instead\&.

.RE
.LP
.B
info_report(Report) -> ok
.br
.RS
.TP
Types
Report = [{Tag, Data} | term()] | string() | term()
.br
 Tag = Data = term()
.br
.RE
.RS
.LP
Sends a standard information report event to the error logger\&. The event is handled by the standard event handler\&.

.nf
2> error_logger:info_report([{tag1,data1},a_term,{tag2,data}])\&.


=INFO REPORT==== 11-Aug-2005::13:55:09 ===
    tag1: data1
    a_term
    tag2: data
ok
3> error_logger:info_report("Something strange happened")\&.


=INFO REPORT==== 11-Aug-2005::13:55:36 ===
Something strange happened
ok
.fi
.RE
.LP
.B
info_report(Type, Report) -> ok
.br
.RS
.TP
Types
Type = term()
.br
Report = [{Tag, Data} | term()] | string() | term()
.br
 Tag = Data = term()
.br
.RE
.RS
.LP
Sends a user defined information report event to the error logger\&. An event handler to handle the event is supposed to have been added\&. The event is ignored by the standard event handler\&.
.LP
It is recommended that \fIReport\fR follows the same structure as for \fIinfo_report/1\fR\&.
.RE
.LP
.B
add_report_handler(Handler) -> Result
.br
.B
add_report_handler(Handler, Args) -> Result
.br
.RS
.TP
Types
Handler, Args, Result -- see gen_event:add_handler/3
.br
.RE
.RS
.LP
Adds a new event handler to the error logger\&. The event handler must be implemented as a \fIgen_event\fR callback module, see gen_event(3)\&.
.LP
\fIHandler\fR is typically the name of the callback module and \fIArgs\fR is an optional term (defaults to []) passed to the initialization callback function \fIModule:init/1\fR\&. The function returns \fIok\fR if successful\&.
.LP
The event handler must be able to handle the events described below\&.
.RE
.LP
.B
delete_report_handler(Handler) -> Result
.br
.RS
.TP
Types
Handler, Result -- see gen_event:delete_handler/3
.br
.RE
.RS
.LP
Deletes an event handler from the error logger by calling \fIgen_event:delete_handler(error_logger, Handler, [])\fR, see gen_event(3)\&.
.RE
.LP
.B
tty(Flag) -> ok
.br
.RS
.TP
Types
Flag = bool()
.br
.RE
.RS
.LP
Enables (\fIFlag == true\fR) or disables (\fIFlag == false\fR) printout of standard events to the tty\&.
.LP
This is done by adding or deleting the standard event handler for output to tty, thus calling this function overrides the value of the Kernel \fIerror_logger\fR configuration parameter\&.
.RE
.LP
.B
logfile(Request) -> ok | Filename | {error, What}
.br
.RS
.TP
Types
Request = {open, Filename} | close | filename
.br
 Filename = atom() | string()
.br
What = allready_have_logfile | no_log_file | term()
.br
.RE
.RS
.LP
Enables or disables printout of standard events to a file\&.
.LP
This is done by adding or deleting the standard event handler for output to file, thus calling this function overrides the value of the Kernel \fIerror_logger\fR configuration parameter\&.
.LP
Enabling file logging can be used in combination with calling \fItty(false)\fR, in order to have a silent system, where all standard events are logged to a file only\&. There can only be one active log file at a time\&.
.LP
\fIRequest\fR is one of:
.RS 2
.TP 4
.B
\fI{open, Filename}\fR:
Opens the log file \fIFilename\fR\&. Returns \fIok\fR if successful, or \fI{error, allready_have_logfile}\fR if logging to file is already enabled, or an error tuple if another error occurred\&. For example, if \fIFilename\fR could not be opened\&.
.TP 4
.B
\fIclose\fR:
Closes the current log file\&. Returns \fIok\fR, or \fI{error, What}\fR\&.
.TP 4
.B
\fIfilename\fR:
Returns the name of the log file \fIFilename\fR, or \fI{error, no_log_file}\fR if logging to file is not enabled\&.
.RE
.RE
.SH EVENTS
.LP
All event handlers added to the error logger must handle the following events\&. \fIGleader\fR is the group leader pid of the process which sent the event, and \fIPid\fR is the process which sent the event\&.
.RS 2
.TP 4
.B
\fI{error, Gleader, {Pid, Format, Data}}\fR:
Generated when \fIerror_msg/1, 2\fR or \fIformat\fR is called\&.
.TP 4
.B
\fI{error_report, Gleader, {Pid, std_error, Report}}\fR:
Generated when \fIerror_report/1\fR is called\&.
.TP 4
.B
\fI{error_report, Gleader, {Pid, Type, Report}}\fR:
Generated when \fIerror_report/2\fR is called\&.
.TP 4
.B
\fI{warning_msg, Gleader, {Pid, Format, Data}}\fR:
Generated when \fIwarning_msg/1, 2\fR is called, provided that warnings are set to be tagged as warnings\&.
.TP 4
.B
\fI{warning_report, Gleader, {Pid, std_warning, Report}}\fR:
Generated when \fIwarning_report/1\fR is called, provided that warnings are set to be tagged as warnings\&.
.TP 4
.B
\fI{warning_report, Gleader, {Pid, Type, Report}}\fR:
Generated when \fIwarning_report/2\fR is called, provided that warnings are set to be tagged as warnings\&.
.TP 4
.B
\fI{info_msg, Gleader, {Pid, Format, Data}}\fR:
Generated when \fIinfo_msg/1, 2\fR is called\&.
.TP 4
.B
\fI{info_report, Gleader, {Pid, std_info, Report}}\fR:
Generated when \fIinfo_report/1\fR is called\&.
.TP 4
.B
\fI{info_report, Gleader, {Pid, Type, Report}}\fR:
Generated when \fIinfo_report/2\fR is called\&.
.RE
.LP
Note that also a number of system internal events may be received, a catch-all clause last in the definition of the event handler callback function \fIModule:handle_event/2\fR is necessary\&. This also holds true for \fIModule:handle_info/2\fR, as there are a number of system internal messages the event handler must take care of as well\&.
.SH SEE ALSO
.LP
gen_event(3), log_mf_h(3), kernel(6), sasl(6)
